=== debian/changelog ===
blis (0.8.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 03 Sep 2021 23:16:38 -0400

blis (0.8.1-1) experimental; urgency=medium

  * New upstream version 0.8.1
  * Refresh existing patches.

 -- Mo Zhou <lumin@debian.org>  Sat, 08 May 2021 13:27:19 +0800
